//
//  MasterViewController.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 16.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class StartPageViewController;
@class OverviewItem;


@interface MasterViewController : UITableViewController <UISearchBarDelegate, UINavigationControllerDelegate>
{
    NSMutableArray*     _categories;
    
    BOOL                _isEditingSearch;
    OverviewItem*       _selectedOverviewItem;
}

@property (nonatomic) StartPageViewController*  rightViewController;

@end


enum OverviewType
{
    LATEST_RELEASES,
    LATEST_ADDITIONS,
    TOP_DEMOS,
    TOP_ONE_FILE_DEMOS,
    TOP_INTROS,
    TOP_CRACK_INTROS,
    TOP_GAMES,
    TOP_GRAPHICS,
    TOP_GRAPHICS_COLLECTION,
    TOP_MUSIC,
    TOP_MUSIC_COLLECTION,
    RECENTLY_COMMENTED,
    RECENTLY_VIEWED,
    FAVORITES,
    SEARCH,
    
    OVERVIEWTYPE_COUNT
};


@interface OverviewItem : NSObject
{
    
    
}

- (id) initWithType:(OverviewType)type andDescription:(NSString*)description andURL:(NSString*)url hasRange:(BOOL)hasRange isHTML:(BOOL)isHTML;

@property (nonatomic) OverviewType type;
@property (nonatomic) NSString* description;
@property (nonatomic) NSString* url;
@property (nonatomic) BOOL hasRange;
@property (nonatomic) BOOL parseHTML;

@end


@interface UIViewController (MasterPopover)

- (void) addMasterPopoverButton:(UIBarButtonItem*)barButtonItem;
- (void) removeMasterPopoverButton:(UIBarButtonItem*)barButtonItem;

@end

