//
//  CSEventItem.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 22.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CSDatabaseItem.h"
#import "TBXML.h"

@interface CSEventItem : CSDatabaseItem


@property (strong, nonatomic) NSString* name;
@property (strong, nonatomic) NSString* alternativeName;
@property (strong, nonatomic) NSString* tagline;
@property (strong, nonatomic) NSDateComponents* startDate;
@property (strong, nonatomic) NSDateComponents* endDate;

- (id) initWithEventId:(NSString*)eventId;

- (id) initWithXMLElement:(TBXMLElement*)eventElement;
- (void) setFromXMLElement:(TBXMLElement*)eventElement;

- (NSComparisonResult) compareStartDates:(CSEventItem*)otherItem;

@end
